/* Tecnisa - Tecnologia em Informtica

 Nome: Movimentao de Estoque

 Descrio:
 Estrutura das tabelas de Movimentao de Estoque

 Criao:
 25/06/2004 - Roberto A. Lopes Martins

 @C:\WEB_411\Sql\End_Conv\Oracle\4000_ESTSTPO_Tabelas_Relatorio.SQL

 A criao das tabelas est duplicado porque em verses mais antigas do
 ORACLE no existe GLOBAL TEMPORARY TABLE.

*/

-- ============================================================
--   Table: RELAT_MOVIEST
-- ============================================================
DROP TABLE RELAT_MOVIEST
/

create GLOBAL TEMPORARY table RELAT_MOVIEST
(
    NRRELATMOVI      VARCHAR2(10)           not null,
    CDFILIMOVIEST    VARCHAR2(4)            not null,
    CDFILLANCMEST    VARCHAR2(4)            not null,
    NRLANCMOVIEST    VARCHAR2(10)           not null,
    NRSEQUMOVIEST    VARCHAR2(4)            not null,
    NRLOTEESTQME     VARCHAR2(20)           not null,
    NRSUBLOTEME      VARCHAR2(4)            not null,
    CDPRODMOVIEST    VARCHAR2(20)           not null,
    DTLANCMOVIEST    DATE                   not null,
    CDALMOXARIRM     VARCHAR2(6)            not null,
    CDLOCALESTRM     VARCHAR2(6)            not null,
    IDTIPOMOVIEST    VARCHAR2(1)            not null,
    QTDEMOVIEST      FLOAT                  null    ,
    VRCUSTMEDI       FLOAT                  null    ,
    VRCUSTMOVIEST    FLOAT                  null    ,
    QTLANCAMENTO     FLOAT                  null    ,
    VRCUSTBRUT       FLOAT                  null    ,
    VRCUSTMEES       FLOAT                  null    ,
    VRCUSTMEBR       FLOAT                  null    ,
    QTLANCMOVIEST    FLOAT                  null    ,
    VRLANCMOVIEST    FLOAT                  null    ,
    VRBRUTMOVIEST    FLOAT                  null    ,
    CDTOTMOVIEST     VARCHAR2(20)           null    ,
    NMPRODMOVIEST    VARCHAR2(50)           null    ,
    IDORDEMCALC      VARCHAR2(1)            null    ,
    IDALTCMEDMOV     VARCHAR2(1)            null    ,
    VRDIFECUST       FLOAT                  null    ,
    VRUNILANCEST     FLOAT                  null    ,
    VRTOTLANCEST     FLOAT                  null    ,
    QTTOTALANT       FLOAT                  null    ,
    VRTOTALANT       FLOAT                  null    ,
    VRCUSTENTRME     FLOAT                  null    ,
    SGUNIDMOVI       VARCHAR2(10)           null    ,
    IDENTRSAIDME     VARCHAR2(1)            null,
        constraint CKC_31738739 check (IDENTRSAIDME is null or (IDENTRSAIDME in ('E','S','-'))),
    CDTIPOOPERME     VARCHAR2(2)            null    ,
    CDTIPORETIME     VARCHAR2(2)            null    ,
    NMTIPORETIME     VARCHAR2(40)           null    ,
    VRCUSTLOGLME     FLOAT                  Null    ,
    VRCUSTSEGLME     FLOAT                  Null    ,
    VRPESOBRUTME     FLOAT                  Null    ,
    VRCUSTLOGEME     FLOAT                  Null    ,
    VRCUSTSEGEME     FLOAT                  Null    ,
    VRDIFCUSTEME     FLOAT                  Null    ,
    constraint PK_RELAT_MOVIEST primary key (NRRELATMOVI, CDFILLANCMEST, NRLANCMOVIEST, NRSEQUMOVIEST, NRLOTEESTQME, NRSUBLOTEME, CDPRODMOVIEST, DTLANCMOVIEST, CDALMOXARIRM, CDLOCALESTRM)
) ON COMMIT PRESERVE ROWS
/

create table RELAT_MOVIEST
(
    NRRELATMOVI      VARCHAR2(10)           not null,
    CDFILIMOVIEST    VARCHAR2(4)            not null,
    CDFILLANCMEST    VARCHAR2(4)            not null,
    NRLANCMOVIEST    VARCHAR2(10)           not null,
    NRSEQUMOVIEST    VARCHAR2(4)            not null,
    NRLOTEESTQME     VARCHAR2(20)           not null,
    NRSUBLOTEME      VARCHAR2(4)            not null,
    CDPRODMOVIEST    VARCHAR2(20)           not null,
    DTLANCMOVIEST    DATE                   not null,
    CDALMOXARIRM     VARCHAR2(6)            not null,
    CDLOCALESTRM     VARCHAR2(6)            not null,
    IDTIPOMOVIEST    VARCHAR2(1)            not null,
    QTDEMOVIEST      FLOAT                  null    ,
    VRCUSTMEDI       FLOAT                  null    ,
    VRCUSTMOVIEST    FLOAT                  null    ,
    QTLANCAMENTO     FLOAT                  null    ,
    VRCUSTBRUT       FLOAT                  null    ,
    VRCUSTMEES       FLOAT                  null    ,
    VRCUSTMEBR       FLOAT                  null    ,
    QTLANCMOVIEST    FLOAT                  null    ,
    VRLANCMOVIEST    FLOAT                  null    ,
    VRBRUTMOVIEST    FLOAT                  null    ,
    CDTOTMOVIEST     VARCHAR2(20)           null    ,
    NMPRODMOVIEST    VARCHAR2(50)           null    ,
    IDORDEMCALC      VARCHAR2(1)            null    ,
    IDALTCMEDMOV     VARCHAR2(1)            null    ,
    VRDIFECUST       FLOAT                  null    ,
    VRUNILANCEST     FLOAT                  null    ,
    VRTOTLANCEST     FLOAT                  null    ,
    QTTOTALANT       FLOAT                  null    ,
    VRTOTALANT       FLOAT                  null    ,
    VRCUSTENTRME     FLOAT                  null    ,
    SGUNIDMOVI       VARCHAR2(10)           null    ,
    IDENTRSAIDME     VARCHAR2(1)            null    ,
        constraint CKC_31738739 check (IDENTRSAIDME is null or (IDENTRSAIDME in ('E','S','-'))),
    CDTIPOOPERME     VARCHAR2(2)            null    ,
    CDTIPORETIME     VARCHAR2(2)            null    ,
    NMTIPORETIME     VARCHAR2(40)           null    ,
    VRCUSTLOGLME     FLOAT                  Null    ,
    VRCUSTSEGLME     FLOAT                  Null    ,
    VRPESOBRUTME     FLOAT                  Null    ,
    VRCUSTLOGEME     FLOAT                  Null    ,
    VRCUSTSEGEME     FLOAT                  Null    ,
    VRDIFCUSTEME     FLOAT                  Null    ,
    constraint PK_RELAT_MOVIEST primary key (NRRELATMOVI, CDFILLANCMEST, NRLANCMOVIEST, NRSEQUMOVIEST, NRLOTEESTQME, NRSUBLOTEME, CDPRODMOVIEST, DTLANCMOVIEST, CDALMOXARIRM, CDLOCALESTRM)
)
/

create index RELAT_MOVIEST_01 on RELAT_MOVIEST (NRRELATMOVI asc, IDTIPOMOVIEST asc, QTLANCAMENTO asc, CDTOTMOVIEST asc, VRCUSTMEDI asc, VRDIFECUST asc)
/

create index RELAT_MOVIEST_02 on RELAT_MOVIEST (NRRELATMOVI asc, IDTIPOMOVIEST asc, CDFILIMOVIEST asc, CDFILLANCMEST asc, NRLANCMOVIEST asc, NRSEQUMOVIEST asc, QTTOTALANT asc, VRCUSTMEDI asc)
/

-- ============================================================
--   Table: RELAT_DESCMOVI
-- ============================================================
DROP TABLE RELAT_DESCMOVI
/

create GLOBAL TEMPORARY table RELAT_DESCMOVI
(
    NRRELATDESC      VARCHAR2(10)           not null,
    CDFILLANCDMOVI   VARCHAR2(4)            not null,
    NRLANCDESCMOVI   VARCHAR2(10)           not null,
    CDPRODDESCMOVI   VARCHAR2(20)           not null,
    IDTIPODESCMOVI   VARCHAR2(1)            not null,
    DTLANCDESCMOVI   DATE                   null    ,
    NMPRODDESCMOVI   VARCHAR2(50)           null    ,
    constraint PK_RELAT_DESCMOVI primary key (NRRELATDESC, CDFILLANCDMOVI, NRLANCDESCMOVI, CDPRODDESCMOVI)
) ON COMMIT PRESERVE ROWS
/

create table RELAT_DESCMOVI
(
    NRRELATDESC      VARCHAR2(10)           not null,
    CDFILLANCDMOVI   VARCHAR2(4)            not null,
    NRLANCDESCMOVI   VARCHAR2(10)           not null,
    CDPRODDESCMOVI   VARCHAR2(20)           not null,
    IDTIPODESCMOVI   VARCHAR2(1)            not null,
    DTLANCDESCMOVI   DATE                   null    ,
    NMPRODDESCMOVI   VARCHAR2(50)           null    ,
    constraint PK_RELAT_DESCMOVI primary key (NRRELATDESC, CDFILLANCDMOVI, NRLANCDESCMOVI, CDPRODDESCMOVI)
)
/

-- ============================================================
--   Table: RELAT_TOTAMOVI
-- ============================================================
DROP TABLE RELAT_TOTAMOVI
/

create GLOBAL TEMPORARY table RELAT_TOTAMOVI
(
    NRRELATTOTA      VARCHAR2(10)           not null,
    CDPRODTOTAMOVI   VARCHAR2(20)           not null,
    IDTIPOTOTAMOVI   VARCHAR2(1)            not null,
    VRSOMPINI        FLOAT                  null    ,
    VRSOMAINV        FLOAT                  null    ,
    VRSOMINVE        FLOAT                  null    ,
    VRSOMENTR        FLOAT                  null    ,
    VRSOMRETI        FLOAT                  null    ,
    VRSOMSAID        FLOAT                  null    ,
    VRSOMDFOR        FLOAT                  null    ,
    VRSOMSATU        FLOAT                  null    ,
    SGUNIDTOTAME     VARCHAR2(10)           null    ,
    VRQTDEPINIME     FLOAT                  null    ,
    VRQTDEAINVME     FLOAT                  null    ,
    VRQTDEINVEME     FLOAT                  null    ,
    VRQTDEENTRME     FLOAT                  null    ,
    VRQTDERETIME     FLOAT                  null    ,
    VRQTDESAIDME     FLOAT                  null    ,
    VRQTDEDFORME     FLOAT                  null    ,
    VRQTDESATUME     FLOAT                  null    ,
    VRSOMCUSTLOG     FLOAT                  null    ,
    VRSOMCUSTSEG     FLOAT                  null    ,
    VRPESOTOTAME     FLOAT                  null    ,
    VRSOMDIFSAID     FLOAT                  null    ,
    constraint PK_RELAT_TOTAMOVI primary key (NRRELATTOTA, CDPRODTOTAMOVI),
    constraint RELAT_TOTAMOVI_01 unique (NRRELATTOTA, IDTIPOTOTAMOVI, CDPRODTOTAMOVI)
) ON COMMIT PRESERVE ROWS
/

create table RELAT_TOTAMOVI
(
    NRRELATTOTA      VARCHAR2(10)           not null,
    CDPRODTOTAMOVI   VARCHAR2(20)           not null,
    IDTIPOTOTAMOVI   VARCHAR2(1)            not null,
    VRSOMPINI        FLOAT                  null    ,
    VRSOMAINV        FLOAT                  null    ,
    VRSOMINVE        FLOAT                  null    ,
    VRSOMENTR        FLOAT                  null    ,
    VRSOMRETI        FLOAT                  null    ,
    VRSOMSAID        FLOAT                  null    ,
    VRSOMDFOR        FLOAT                  null    ,
    VRSOMSATU        FLOAT                  null    ,
    SGUNIDTOTAME     VARCHAR2(10)           null    ,
    VRQTDEPINIME     FLOAT                  null    ,
    VRQTDEAINVME     FLOAT                  null    ,
    VRQTDEINVEME     FLOAT                  null    ,
    VRQTDEENTRME     FLOAT                  null    ,
    VRQTDERETIME     FLOAT                  null    ,
    VRQTDESAIDME     FLOAT                  null    ,
    VRQTDEDFORME     FLOAT                  null    ,
    VRQTDESATUME     FLOAT                  null    ,
    VRSOMCUSTLOG     FLOAT                  null    ,
    VRSOMCUSTSEG     FLOAT                  null    ,
    VRPESOTOTAME     FLOAT                  null    ,
    VRSOMDIFSAID     FLOAT                  null    ,
    constraint PK_RELAT_TOTAMOVI primary key (NRRELATTOTA, CDPRODTOTAMOVI),
    constraint RELAT_TOTAMOVI_01 unique (NRRELATTOTA, IDTIPOTOTAMOVI, CDPRODTOTAMOVI)
)
/

-- ============================================================
--   Table: RELAT_ANALMOVI
-- ============================================================
DROP TABLE RELAT_ANALMOVI
/

create GLOBAL TEMPORARY table RELAT_ANALMOVI
(
    NRRELATANAL      VARCHAR2(10)           not null,
    IDSALDOESTAN     VARCHAR2(2)            not null,
        constraint CKC_32007271 check (IDSALDOESTAN in ('SA','SJ','SI','SE','SR','SS','ST','SL','SG','SP')),
    CDTIPORETIAN     VARCHAR2(2)            not null,
    IDENTRSAIDAN     VARCHAR2(1)            not null,
        constraint CKC_32007273 check (IDENTRSAIDAN in ('E','S','-')),
    CDTIPOOPERAN     VARCHAR2(2)            not null,
    VRSALDOESTAN     FLOAT                  null    ,
    QTSALDOESTAN     FLOAT                  null    ,
    NMTIPORETIAN     VARCHAR2(40)           null    ,
    constraint PK_RELAT_ANALMOVI primary key (NRRELATANAL, IDSALDOESTAN, CDTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN)
) ON COMMIT PRESERVE ROWS
/

create table RELAT_ANALMOVI
(
    NRRELATANAL      VARCHAR2(10)           not null,
    IDSALDOESTAN     VARCHAR2(2)            not null,
        constraint CKC_32007271 check (IDSALDOESTAN in ('SA','SJ','SI','SE','SR','SS','ST','SL','SG','SP')),
    CDTIPORETIAN     VARCHAR2(2)            not null,
    IDENTRSAIDAN     VARCHAR2(1)            not null,
        constraint CKC_32007273 check (IDENTRSAIDAN in ('E','S','-')),
    CDTIPOOPERAN     VARCHAR2(2)            not null,
    VRSALDOESTAN     FLOAT                  null    ,
    QTSALDOESTAN     FLOAT                  null    ,
    NMTIPORETIAN     VARCHAR2(40)           null    ,
    constraint PK_RELAT_ANALMOVI primary key (NRRELATANAL, IDSALDOESTAN, CDTIPORETIAN, IDENTRSAIDAN, CDTIPOOPERAN)
)
/

-- VERSAO --
BEGIN ATUVEROBJ('TABELAS_RELATORIO','4.11.089'); END;

/

