/* Sistemas Integrados TECNISA
   Compras e Suprimentos

Nome: EXPORTA_REFORFIL

Descrio:
Exporta o cadastro de fornecedor no atende/atende de uma filial origem para uma
ou mais filiais destino

P_NRLISTA      - Lista de filiais destino
P_CDFILORIG    - Filial Origem

Criao:
06/09/2006 - Marcelo Alexsandro Souza Silva
*/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'EXPORTA_REFORFIL'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
   DROP PROCEDURE EXPORTA_REFORFIL;
GO

CREATE PROCEDURE EXPORTA_REFORFIL
  @P_NRLISTA   VARCHAR(10),
  @P_CDFILORIG VARCHAR(4)
AS
  DECLARE @V_CDLISTA    VARCHAR(4);
  DECLARE @V_CDFORNECED VARCHAR(21);
  DECLARE @V_CDFILIAL   VARCHAR(4);
  DECLARE @V_CDPERIENTR VARCHAR(2);
BEGIN
   DECLARE CUR_FILIAL CURSOR FOR
      SELECT LISTA.CDLISTA
        FROM FILIAL INNER JOIN LISTA ON LISTA.CDLISTA = FILIAL.CDFILIAL
       WHERE LISTA.NRLISTA = @P_NRLISTA
       ORDER BY CDLISTA
   OPEN CUR_FILIAL;
   FETCH NEXT FROM CUR_FILIAL INTO @V_CDLISTA;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      BEGIN TRANSACTION
         DELETE FROM REFORFIL
               WHERE CDFILIAL = @V_CDLISTA;

         INSERT INTO REFORFIL (CDFORNECED, CDFILIAL, CDPERIENTR)
             (SELECT R.CDFORNECED, @V_CDLISTA CDFILIAL, R.CDPERIENTR
                FROM REFORFIL R
               WHERE R.CDFILIAL = @P_CDFILORIG);

      COMMIT TRANSACTION;

      FETCH NEXT FROM CUR_FILIAL INTO @V_CDLISTA;
   END;
   CLOSE CUR_FILIAL;
   DEALLOCATE CUR_FILIAL;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'EXPORTA_REFORFIL','6.10.XXX';
GO
